#!/usr/bin/zsh
############################################################
### Slurm flags
############################################################

#SBATCH --time=00:15:00
#SBATCH --partition=c23g
#SBATCH --nodes=1
#SBATCH --ntasks-per-node=1
#SBATCH --cpus-per-task=24
#SBATCH --gres=gpu:1

############################################################
### Load modules or software
############################################################

# load module for PyTorch container
module load PyTorch/nvcr-24.01-py3
module list

############################################################
### Parameters and Settings
############################################################

# print some information about current system
echo "Job nodes: ${SLURM_JOB_NODELIST}"
echo "Current machine: $(hostname)"
nvidia-smi

############################################################
### Execution (Model Training)
############################################################

# run the python script inside the container
apptainer exec -e --nv ${PYTORCH_IMAGE} \
    bash -c "python train_model.py"